// -----------------------------------------------------------------------------
// date:	Wed Oct 14 12:07:08 DFT 1998
// version:	2.0
// author:	D.Garrivier
// title:	list
// comment:	basic list with templates
// note:	the file containging the definition is named list.c and not
// 		list.C because of the auto-template generation from xlC.
//		Class used for templates needs to be in an outside header file.
// -----------------------------------------------------------------------------

#if !defined(IOSTREAM)
	#define IOSTREAM
	#include <iostream.h>
#endif

//===========================================================================
//========= Base types for Lists ============================================
//===========================================================================

struct BaseLink
{
private:
	friend class BaseList;
	friend class BaseListIterator;
	BaseLink *pNext;
public:
	BaseLink(){pNext=0;}
	BaseLink(BaseLink* pBL){pNext=pBL;}
};

//----------------------------------------------------------------------------

class BaseList
{
private:
	BaseLink *pLast;
	friend class BaseListIterator;
public:
	BaseList(){pLast=0;}
	void Insert(BaseLink* a);
};

//----------------------------------------------------------------------------

class BaseListIterator
{
protected:
	BaseList* pBaseList;
	BaseLink* pCurr;
public:
	BaseLink* operator& ()	{ return pCurr; }
	BaseListIterator(BaseList &s);
	BaseLink* operator()();
	BaseListIterator operator++(int);
	void GotoFirst();
	void GotoLast(){pCurr=pBaseList->pLast;}
};

//===========================================================================
//========= derivated types for Lists =======================================
//===========================================================================

template <class T>
struct Link : public BaseLink
{
	friend class BaseList;
	friend class BaseListIterator;
	friend class List<T>;
	friend class ListIterator<T>;
private:
	T info;
	Link(const T&a) : info(a) { }
};

//----------------------------------------------------------------------------

template <class T>
class List : public BaseList
{
public:
	List(void){N=0;};
	int size(void){return N;}
	void Insert(const T& a)	
      		{ BaseList::Insert(new Link<T>(a)); N++;}
/*	void Show()	{ ListIterator<T> It(*this);
                while (It) { cout<<It()<<", "; It++;}
               }
*/
protected:
	int N;
};


//----------------------------------------------------------------------------

template<class T>
class ListIterator : public BaseListIterator
{
	friend List<T>;
public: 
	operator T*();		// type tranform to pointer on content
	T* operator->();
	ListIterator(List<T> &L) : BaseListIterator(L) { }
	T operator()();
};

